<?php

defined('ABSPATH') or die("No script kiddies please!");



/*-----------------------------------------------------------------------------------*/
/*	Licence management section
/*-----------------------------------------------------------------------------------*/

if ( ! function_exists( 'ag_plugin_licence' ) ) {

	add_action('admin_menu', 'ag_plugin_licence');
	function ag_plugin_licence() {
	  add_menu_page('AG License Activation Menu', 'AG Plugins', 'manage_options', 'AG_licence', 'AG_plugins_page', 'dashicons-admin-network');
	}

}


if ( ! function_exists( 'AG_plugins_page' ) ) {

	function AG_plugins_page() {
	    echo '<div class="wrap">';
	    echo '<h2>We are AG Plugin License Management</h2>';
			echo '<p>Please enter the license key for this product to activate it. You were given a license key when you purchased this item.</p>';

			do_action( 'load_ag_plugins' );

			echo '<p>When moving plugin from one site to another (from development server to live site) you <strong>MUST</strong> deactivate your plugin first on development before you move it over.</p>';
	    echo '</div>';
	}

}

/*-----------------------------------------------------------------------------------*/
/*	End
/*-----------------------------------------------------------------------------------*/


add_action( 'load_ag_plugins', 'epdq_licence_setting' );
function epdq_licence_setting() {

	/*** License activate button was clicked ***/
	if (isset($_REQUEST['PS_ePDQ_key_activate_license'])) {
		$license_key = $_REQUEST['PS_ePDQ_key'];

		// API query parameters
		$api_params = array(
			'slm_action' => 'slm_activate',
			'secret_key' => AGD_KEY,
			'license_key' => $license_key,
			'registered_domain' => $_SERVER['SERVER_NAME'],
			'item_reference' => urlencode(ITEM),
			'product_id' => '1283, 2132, 2133, 2134',
		);

		// Send query to the license manager server
		$query = esc_url_raw(add_query_arg($api_params, AGD));
		$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));

		// License data.
		$license_data = json_decode(wp_remote_retrieve_body($response));

		// TODO - Do something with it.
		//var_dump($license_data);//uncomment it to look at the data

		if($license_data->result == 'success'){//Success was returned for the license activation
				update_option('PS_ePDQ_key', $license_key);
				update_option('PS_ePDQ_key_message', $license_data->message);
				add_option('PS_ePDQ_key_message', $license_data->message);
				$fulldate = $response['headers']['expires'];
				$words = explode(" ", $fulldate);
				$date = join(" ", array_slice($words, 0, 4));
				add_option('PS_ePDQ_key_expires', $date);
				update_option('PS_ePDQ_key_expires', $date);
		} else {
			update_option('PS_ePDQ_key_message', $license_data->message);
		}

	}
	/*** End of license activation ***/

	/*** License activate button was clicked ***/
	if (isset($_REQUEST['PS_ePDQ_key_deactivate_license'])) {
		$license_key = $_REQUEST['PS_ePDQ_key'];

		// API query parameters
		$api_params = array(
			'slm_action' => 'slm_deactivate',
			'secret_key' => AGD_KEY,
			'license_key' => $license_key,
			'registered_domain' => $_SERVER['SERVER_NAME'],
			'item_reference' => urlencode(ITEM),
			'product_id' => '1283, 2132, 2133, 2134',
		);

		// Send query to the license manager server
		$query = esc_url_raw(add_query_arg($api_params, AGD));
		$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));
		$license_data = json_decode(wp_remote_retrieve_body($response));
		if($license_data->result == 'success'){//Success was returned for the license activation
				//Remove the licensse key from the options table. It will need to be activated again.
				update_option('PS_ePDQ_key', '');
				update_option('PS_ePDQ_key_message', $license_data->message);
				echo $response->headers->expires;
		} else {
			update_option('PS_ePDQ_key_message', $license_data->message);
		}

	}

?>
<form action="" method="post" style="padding-top: 20px; padding-bottom: 20px;">
	<table class="form-table">
		<tr><br  />
      <label class="licence_label" for="PS_ePDQ_key"><strong>ePDQ Licence Key</strong></label>
      <th style="width:10px;  padding-bottom: 0;"><input class="regular-text" type="password" id="PS_ePDQ_key" name="PS_ePDQ_key"  value="<?php echo get_option('PS_ePDQ_key'); ?>" ><input type="submit" name="PS_ePDQ_key_activate_license" value="Activate" class="button-primary activate_license" /><input type="submit" name="PS_ePDQ_key_deactivate_license" value="Deactivate" class="button" />
				<?php if (get_option('PS_ePDQ_key_message') == 'License key activated') {
					echo '<p style="color: green"><strong>'. get_option('PS_ePDQ_key_message'). '</strong></p>';
				} elseif (get_option('PS_ePDQ_key_message') == 'Your License key has expired') {
					echo '<p style="color: red"><strong>'. get_option('PS_ePDQ_key_message'). ' to continue getting support and updates make sure you <a href="">update your licence here</a> now.</strong></p>';
				} else {
					echo '<p style="color: red"><strong>'. get_option('PS_ePDQ_key_message'). '</strong></p>';
				} ?>
  <br  /></tr>
	</table>
	<p style="margin-top: 0; ">Need some help setting up this plugin? <a href="<?php echo site_url(); ?>/wp-admin/index.php?page=welcome-screen-about">Click here</a></p>
</form>
<hr />

<?php

}



class epdq_checkout extends WC_Payment_Gateway {



public function __construct() {
		global $woocommerce;

		$this->id 			= 'epdq_checkout';
		$this->method_title = 'AG EPDQ Checkout';

		$this->icon			= apply_filters( 'woocommerce_epdq_checkout_icon', '' );


		$this->has_fields 	= false;

		$license = get_option('PS_ePDQ_key');
		$api_params = array(
			'slm_action' => 'slm_check',
			'secret_key' => AGD_KEY,
			'license_key' => $license,
		);
		$query = esc_url_raw(add_query_arg($api_params, AGD));
		$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));
		$license_data = json_decode(wp_remote_retrieve_body($response));

		// Load the settings.
		if($license_data->result == 'success'){
			if($this->get_option('refund') == 'yes') {
				$this->init_form_fields_refund();
			} else {
				$this->init_form_fields();
			}
			$this->init_settings();
		}


		$this->title 		= $this->get_option( 'title' );
		$this->title 		= (isset($this->title) and $this->title !='') ? $this->title : 'EPDQ Checkout';
		$this->access_key 	= $this->get_option( 'access_key' );
		$this->api_user 	= $this->get_option( 'api_user' );
		$this->api_password 	= $this->get_option( 'api_password' );
		$this->test_url 	= 'https://mdepayments.epdq.co.uk/ncol/test/orderstandard.asp';
		$this->live_url 	= 'https://payments.epdq.co.uk/ncol/prod/orderstandard.asp';
		$this->status 		= $this->get_option('status');
		$this->error_notice = $this->get_option('error_notice');
		$this->sha_in 		= $this->get_option('sha_in');
		$this->sha_out 		= $this->get_option('sha_out');
		$this->sha_method 	= $this->get_option('sha_method');
		$this->debug	 	= $this->get_option('debug');
		$this->showcase	 	= $this->get_option('showcase');
		$this->logo	 		= $this->get_option('logo');
		$this->cardtypes  = $this->get_option('cardtypes');
		$this->TITLE = $this->get_option('TITLE');
		$this->sha_method 	= ($this->sha_method !='') ? $this->sha_method : 0;


		if ( $this->status == 'test' ) {
			$this->description 	= $this->get_option( 'description' );
			$this->description .= '<br /><br />' . sprintf( __( '<br /><br /><strong>TEST MODE ACTIVE.</strong><br />In test mode, you can use Visa card number 4444 3333 2222 1111 with any CVC and a valid expiration date or check the documentation <a target="_blank" href="%s">here</a> for more card numbers, steps on setting up and troubleshooting.' ), 'https://www.weareag.co.uk/product/ag-barclays-epdq-payment-gateway-woocommerce/' );
			$this->description  = trim( $this->description );
		} else {
			$this->description 	= $this->get_option( 'description' );
		}





		// Supports

		//
		// TODO -- 'subscription_date_changes'
		//
		$this->supports = array( 'refunds' );
		//$this->supports = array( 'refunds', 'subscription_date_changes', 'subscriptions'  );


		$this->aavscheck = $this->get_option('aavcheck');
		$this->cvccheck = $this->get_option('cvccheck');

		// Save options
		add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );

		// Payment listener/API hook
		//add_action('woocommerce_thankyou_epdq_checkout', array($this, 'thank_you'));
		//add_action( 'woocommerce_api_woocommerce_epdq_checkout', array( $this, 'successful_request' ) );
		add_action( 'woocommerce_receipt_epdq_checkout', array( $this, 'receipt_page' ) );

		add_action('woocommerce_api_epdq_checkout', array($this, 'check_response'));

	}

	function get_icon() {

		$icon = '';
		if ( !$this->cardtypes ) {
			// default behavior
			$icon = '<img src="' . plugins_url('AG-woocommerce-epdq-payment-gateway/cards.gif') . '" alt="' . $this->title . '" />';
		} elseif ( $this->cardtypes ) {
			// display icons for the selected card types
			$icon = '';
			foreach ( $this->cardtypes as $cardtype ) {
					$icon .= '<img style="margin-left:5px; margin-right: 5px;" src="' . plugins_url( '/new-card/' . strtolower( $cardtype ) . '.png', __FILE__ ) . '" alt="' . strtolower( $cardtype ) . '" />';
			}
		}

		return apply_filters( 'woocommerce_gateway_icon', $icon, $this->id );
	}

	public function admin_options() {
		global $woocommerce;
		?>

		<h3><?php _e( 'AG ePDQ Checkout Settings', 'ag_epdq_checkout' ); ?></h3>
		<p><?php _e('Barclays ePDQ Payment gateway to accept payments directly into your Barclays account. <br /> This gateway will redirect the customers to the secured Barclay payment server and process the order there, Once payment is made Barclays will send them back to the provided links based on the status of their transaction.','ag_epdq_checkout')?></p>

	<?php

		$license = get_option('PS_ePDQ_key');
		$api_params = array(
			'slm_action' => 'slm_check',
			'secret_key' => AGD_KEY,
			'license_key' => $license,
		);
		$query = esc_url_raw(add_query_arg($api_params, AGD));
		$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));
		$license_data = json_decode(wp_remote_retrieve_body($response));
		echo '<strong>';
		echo $license_data->message;
		echo '</strong>';
		if($license_data->result == 'success'){
			echo '<br />Thank You Purchasing!';
		} else {
			echo '<br />Please activate your licence <a href="'. site_url() .'/wp-admin/admin.php?page=AG_licence">here</a>';
		} ?>
			<table class="form-table">
				<?php $this->generate_settings_html(); ?>
			</table> <!--/.form-table-->

<p>Need some help setting up this plugin? <a href="<?php echo site_url(); ?>/wp-admin/index.php?page=welcome-screen-about">Click here</a></p>



		<?php

	  }

		public function init_form_fields() {
			$this->epdqcardtypes = apply_filters( 'wc_epdq_cardtypes', array(
				'mastercard'		=> __( 'MasterCard', 'ag_epdq_checkout' ),
				'amex' 	=> __( 'American Express', 'ag_epdq_checkout' ),
				'maestro'			=> __( 'Maestro', 'ag_epdq_checkout' ),
				'visa'				=> __( 'Visa', 'ag_epdq_checkout' ),
				//'​MCDEBIT'	=> __( 'MasterCard Debit', 'ag_epdq_checkout' ),
				//'DELTA'		=> __( 'Visa Debit', 'ag_epdq_checkout' ),
				//'Discover'			=> __( 'Discover', 'ag_epdq_checkout' ),
				//'JCB'				=> __( 'JCB', 'ag_epdq_checkout' ),
				//'Laser'				=> __( 'Laser', 'ag_epdq_checkout' ),
			) );

			$this->form_fields = array(
					'enabled' => array(
							'title' => __( 'Enable/Disable', 'ag_epdq_checkout' ),
							'type' => 'checkbox',
							'label' => __( 'Enable EPDQ Checkout', 'ag_epdq_checkout' ),
							'default' => 'no'
					),
					'logo' => array(
						'title' => __( 'Logo for payment page', 'ag_epdq_checkout' ),
						'type' => 'text',
						'label' => __( 'Upload image for payment page', 'ag_epdq_checkout' ),
						'default' => '',
						'description'=>'Add an image to display on the payment page - paste in the full image url <strong>You must have an SSL for this to work correctly.</strong>',
						'desc_tip'=>false
					),
					'title' => array(
							'title' => __( 'Title', 'ag_epdq_checkout' ),
							'type' => 'text',
							'description' => __( 'Title of the payment process. This name will be visible throughout the site and the payment page.', 'ag_epdq_checkout' ),
							'default' => 'EPDQ Checkout',
							'desc_tip'      => true
					),
					'description' => array(
							'title' => __( 'Description', 'ag_epdq_checkout' ),
							'type' => 'textarea',
							'description' => __( 'Description of the payment process. This description will be visible throuhout the site and the payment page.', 'ag_epdq_checkout' ),
							'default' => 'Use the payment processor of barclay bank and checkout with your debit/credit card.',
							'desc_tip'      => true
					),
					'access_key' => array(
							'title' => __( 'PSPID', 'ag_epdq_checkout' ),
							'type' => 'text',
							'description' => __( 'The PSPID for your barclays account. This is the id which you use to login the admin panel of the barclays bank.', 'ag_epdq_checkout' ),
							'default' => '',
							'desc_tip'      => true
					),
					'status' => array(
							'title' => __( 'Store Status', 'ag_epdq_checkout' ),
							'type' => 'select',
							'options'=> array('test'=>'Test Environment','live'=>'Live Store'),
							'description' => __( 'The status of your store tells that are you actually ready to run your shop or its still a test environment. If the test is selected then no payments will be processed. For details please refer to the user guide provided by the Barclays EPDQ servise.', 'ag_epdq_checkout' ),
							'default' => '',
							'css'  => 'height: 35px;',
							'desc_tip'      => true,
					),
					'sha_in' => array(
							'title' => __( 'SHA-IN Passphrase', 'ag_epdq_checkout' ),
							'type' => 'text',
							'description' => __( 'The SHA-IN signature will encode the parameter passed to the payment processor via the hidden fields to ensure better security.', 'ag_epdq_checkout' ),
							'default' => '',
							'desc_tip'      => true
					),
					'sha_out' => array(
							'title' => __( 'SHA-OUT Passphrase', 'ag_epdq_checkout' ),
							'type' => 'text',
							'description' => __( 'The SHA-OUT signature will encode the parameter passed to the redirection url from the payment processor to ensure better security.', 'ag_epdq_checkout' ),
							'default' => 0,
							'desc_tip'      => true
					),
					'sha_method' => array(
							'title' => __( 'SHA encription method', 'ag_epdq_checkout' ),
							'type' => 'select',
							'css'  => 'height: 35px;',
							'options'=> array(0=>'SHA-1',1=>'SHA-256',2=>'SHA-512'),
							'description' => __( 'Sha encryption method - this needs to be similar waht you have set in the epdq backoffice.', 'ag_epdq_checkout' ),
							'default' => '',
							'desc_tip'      => true,
					),
					'cardtypes'	=> array(
						'title' 		=> __( 'Accepted Cards', 'ag_epdq_checkout' ),
						'type' 			=> 'multiselect',
						'class'			=> 'chosen_select',
						'css'         	=> 'width: 350px;',
						'description' 	=> __( 'Select which card types to accept. This is to show card icons on the checkout only.', 'ag_epdq_checkout' ),
						'default' 		=> '',
						'options' 		=> $this->epdqcardtypes,
					),
					'refund' => array(
						'title' => __( 'Refunds', 'ag_epdq_checkout' ),
						'type' => 'checkbox',
						'label' => __( 'Process refunds in order screen', 'ag_epdq_checkout' ),
						'default' => '',
						'description'=>'Once the save changes button has been clicked two new fields will show which will need to be set to process refunds on the website.',
						'desc_tip'=>true
					),

			);

		}

	public function init_form_fields_refund() {
		$this->epdqcardtypes = apply_filters( 'wc_epdq_cardtypes', array(
			'mastercard'		=> __( 'MasterCard', 'ag_epdq_checkout' ),
			'amex' 	=> __( 'American Express', 'ag_epdq_checkout' ),
			'maestro'			=> __( 'Maestro', 'ag_epdq_checkout' ),
			'visa'				=> __( 'Visa', 'ag_epdq_checkout' ),
			//'​MCDEBIT'	=> __( 'MasterCard Debit', 'ag_epdq_checkout' ),
			//'DELTA'		=> __( 'Visa Debit', 'ag_epdq_checkout' ),
			//'Discover'			=> __( 'Discover', 'ag_epdq_checkout' ),
			//'JCB'				=> __( 'JCB', 'ag_epdq_checkout' ),
			//'Laser'				=> __( 'Laser', 'ag_epdq_checkout' ),
		) );

		$this->form_fields = array(
				'enabled' => array(
						'title' => __( 'Enable/Disable', 'ag_epdq_checkout' ),
						'type' => 'checkbox',
						'label' => __( 'Enable EPDQ Checkout', 'ag_epdq_checkout' ),
						'default' => 'no'
				),
				'logo' => array(
					'title' => __( 'Logo for payment page', 'ag_epdq_checkout' ),
					'type' => 'text',
					'label' => __( 'Upload image for payment page', 'ag_epdq_checkout' ),
					'default' => '',
					'description'=>'Add an image to display on the payment page - paste in the full image url <strong>You must have an SSL for this to work correctly.</strong>',
					'desc_tip'=>false
				),
				'title' => array(
						'title' => __( 'Title', 'ag_epdq_checkout' ),
						'type' => 'text',
						'description' => __( 'Title of the payment process. This name will be visible throughout the site and the payment page.', 'ag_epdq_checkout' ),
						'default' => 'EPDQ Checkout',
						'desc_tip'      => true
				),
				'description' => array(
						'title' => __( 'Description', 'ag_epdq_checkout' ),
						'type' => 'textarea',
						'description' => __( 'Description of the payment process. This description will be visible throuhout the site and the payment page.', 'ag_epdq_checkout' ),
						'default' => 'Use the payment processor of barclay bank and checkout with your debit/credit card.',
						'desc_tip'      => true
				),
				'access_key' => array(
						'title' => __( 'PSPID', 'ag_epdq_checkout' ),
						'type' => 'text',
						'description' => __( 'The PSPID for your barclays account. This is the id which you use to login the admin panel of the barclays bank.', 'ag_epdq_checkout' ),
						'default' => '',
						'desc_tip'      => true
				),
				'status' => array(
						'title' => __( 'Store Status', 'ag_epdq_checkout' ),
						'type' => 'select',
						'css'  => 'height: 35px;',
						'options'=> array('test'=>'Test Environment','live'=>'Live Store'),
						'description' => __( 'The status of your store tells that are you actually ready to run your shop or its still a test environment. If the test is selected then no payments will be processed. For details please refer to the user guide provided by the Barclays EPDQ servise.', 'ag_epdq_checkout' ),
						'default' => '',
						'desc_tip'      => true,
				),
				'sha_in' => array(
						'title' => __( 'SHA-IN Passphrase', 'ag_epdq_checkout' ),
						'type' => 'text',
						'description' => __( 'The SHA-IN signature will encode the parameter passed to the payment processor via the hidden fields to ensure better security.', 'ag_epdq_checkout' ),
						'default' => '',
						'desc_tip'      => true
				),
				'sha_out' => array(
						'title' => __( 'SHA-OUT Passphrase', 'ag_epdq_checkout' ),
						'type' => 'text',
						'description' => __( 'The SHA-OUT signature will encode the parameter passed to the redirection url from the payment processor to ensure better security.', 'ag_epdq_checkout' ),
						'default' => 0,
						'desc_tip'      => true
				),
				'sha_method' => array(
						'title' => __( 'SHA encription method', 'ag_epdq_checkout' ),
						'type' => 'select',
						'css'  => 'height: 35px;',
						'options'=> array(0=>'SHA-1',1=>'SHA-256',2=>'SHA-512'),
						'description' => __( 'Sha encryption method - this needs to be similar waht you have set in the epdq backoffice.', 'ag_epdq_checkout' ),
						'default' => '',
						'desc_tip'      => true,
				),
				'cardtypes'	=> array(
					'title' 		=> __( 'Accepted Cards', 'ag_epdq_checkout' ),
					'type' 			=> 'multiselect',
					'class'			=> 'chosen_select',
					'css'         	=> 'width: 350px;',
					'description' 	=> __( 'Select which card types to accept. This is to show card icons on the checkout only.', 'ag_epdq_checkout' ),
					'default' 		=> '',
					'options' 		=> $this->epdqcardtypes,
				),
				'refund' => array(
					'title' => __( 'Refunds', 'ag_epdq_checkout' ),
					'type' => 'checkbox',
					'label' => __( 'Process refunds in order screen', 'ag_epdq_checkout' ),
					'default' => '',
					'description'=>'Once the save changes button has been clicked two new fields will show which will need to be set to process refunds on the website.',
					'desc_tip'=>true
				),
				'api_user' => array(
					'title'		=> __( 'API User ID', 'ag_epdq_checkout' ),
					'type'		=> 'text',
					'desc_tip'	=> __( 'This is to enable you to process refunds via the order screen', 'ag_epdq_checkout' ),
				),
				'api_password' => array(
					'title'		=> __( 'API User Password', 'ag_epdq_checkout' ),
					'type'		=> 'text',
					'desc_tip'	=> __( 'This is to enable you to process refunds via the order screen', 'ag_epdq_checkout' ),
				),

		);

	}




	/*-----------------------------------------------------------------------------------*/
	/*	Process the payment and return the result
	/*-----------------------------------------------------------------------------------*/
	public function process_payment($order_id){

		$order = new WC_Order( $order_id );

		return array(
			'result' 	=> 'success',
			'redirect'	=> $order->get_checkout_payment_url( true )
		);

	}


	/*-----------------------------------------------------------------------------------*/
	/*	receipt_page
	/*-----------------------------------------------------------------------------------*/
	public function receipt_page($order_id){
		global $woocommerce;
		$order = new WC_Order( $order_id );

		//$this->notify_url = str_replace( 'https:', 'http:', add_query_arg( 'wc-api', 'epdq_checkout', $order->get_checkout_order_received_url() ) );
		$order_received_url = WC()->api_request_url( 'epdq_checkout' );
	//	if ( ! WC_Subscriptions_Cart::cart_contains_subscription() ) {
			$fields = array(
					'PSPID'=>$this->access_key,
					'ORDERID'=>$order->id,
					'AMOUNT'=>$order->order_total*100,
					'CURRENCY'=>get_woocommerce_currency(),
					'LANGUAGE'=>get_bloginfo('language'),
					'CN'=>$order->billing_first_name . ' ' . $order->billing_last_name,
					'EMAIL'=>$order->billing_email,
					'OWNERZIP'=>preg_replace('/[^A-Za-z0-9\. -]/', '', $order->billing_postcode),
					'OWNERADDRESS'=>preg_replace('/[^A-Za-z0-9\. -]/', '', $order->billing_address_1),
					'OWNERADDRESS2'=>preg_replace('/[^A-Za-z0-9\. -]/', '', $order->billing_address_2),
					'OWNERCTY'=>preg_replace('/[^A-Za-z0-9\. -]/', '', $woocommerce->countries->countries[$order->billing_country]),
					'OWNERTOWN'=>preg_replace('/[^A-Za-z0-9\. -]/', '', $order->billing_city),
					'OWNERTELNO'=>$order->billing_phone,
					'ACCEPTURL'=>$order_received_url,
					'LOGO'=>$this->logo,
					'TITLE'=> '',

			);
	//	} else {
	//		$fields = array(
	//				'PSPID'=>$this->access_key,
	//				'ORDERID'=>$order->id,
	//				'AMOUNT'=>$order->order_total*100,
	//				'CURRENCY'=>get_woocommerce_currency(),
	//				'LANGUAGE'=>get_bloginfo('language'),
	//				'CN'=>$order->billing_first_name . ' ' . $order->billing_last_name,
	//				'EMAIL'=>$order->billing_email,
	//				'OWNERZIP'=>$order->billing_postcode,
	//				'OWNERADDRESS'=>$order->billing_address_1,
	//				'OWNERADDRESS2'=>$order->billing_address_2,
	//				'OWNERCTY'=>$woocommerce->countries->countries[$order->billing_country],
	//				'OWNERTOWN'=>$order->billing_city,
	//				'OWNERTELNO'=>$order->billing_phone,
	//				'ACCEPTURL'=>$order->get_checkout_order_received_url(),
	//				'LOGO'=>$this->logo,
	//				'TITLE'=> '',
	//				'ALIAS'=> 'testme',
	//				'ALIASUSAGE'=> 'added to test'
	//		);
	//	}


		$shasign ='';
		$shasign_arg = array();
		ksort($fields);
		foreach($fields as $key => $value){
			if($value=='') continue;
			$shasign_arg[] =  $key .'='. $value;
		}

		if( $this->sha_method == 0 )
			$shasign = sha1(implode($this->sha_in, $shasign_arg).$this->sha_in);
		elseif ( $this->sha_method == 1 )
			$shasign = hash('sha256',implode($this->sha_in, $shasign_arg).$this->sha_in);
		elseif ( $this->sha_method == 2 )
			$shasign = hash('sha512',implode($this->sha_in, $shasign_arg).$this->sha_in);
		else{}

		$epdq_args = array();
		foreach($fields as $key => $value){
			if($value=='') continue;
			$epdq_args[] = "<input type='hidden' name='$key' value='$value'/>";
		}

		if( isset($this->status) and ($this->status=='test' or $this->status =='live') ):
			if($this->status=='test')	$url = $this->test_url;
			if($this->status=='live')	$url = $this->live_url;

			echo '<p>'.__('Thank you for your order, please click the button below to pay securely.', 'ag_epdq_checkout').'</p>';
			echo '<form action="'.$url.'" method="post" id="epdq_payment_form">';
			echo implode('', $epdq_args);
			echo '<input type="hidden" name="SHASIGN" value="'.$shasign.'"/>';
			echo '<input type="hidden" id="register_nonce" name="register_nonce" value="'.wp_create_nonce('generate-nonce').'" />';
			wp_nonce_field('register_nonce');
			echo '<input type="submit" class="button alt" id="submit_epdq_payment_form" value="'.__('Pay securely', 'ag_epdq_checkout').'" />';
			echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
			echo '<a class="button cancel" href="'.$order->get_cancel_order_url().'">'.__('Cancel order &amp; restore cart', 'ag_epdq_checkout').'</a></form>';
		else:
			echo '<p class="error">'.$this->error_notice.'</p>';
		endif;

		wc_enqueue_js('
			jQuery("body").block({
					message: "'.__('You are now redirecting to Barclays server to make payment securly.', 'ag-epdq').'",
					overlayCSS:
					{
						background: "#fff",
						opacity: 0.6
					},
					css: {
								padding:        20,
								textAlign:      "center",
								color:          "#555",
								border:         "3px solid #aaa",
								backgroundColor:"#fff",
								cursor:         "wait",
								lineHeight:		"32px"
						}
				});
			jQuery("#submit_epdq_payment_form").click();
		');
	}


	function successful_request() {
	}

	function check_response(){


		$check_data = array(
			'ORDERID'	=>	isset($_REQUEST['orderID']) ? $_REQUEST['orderID'] : '',
			'CURRENCY'	=>	isset($_REQUEST['currency']) ? $_REQUEST['currency'] : '',
			'AMOUNT'	=>	isset($_REQUEST['amount']) ? $_REQUEST['amount'] : '',
			'PM'		=>	isset($_REQUEST['PM']) ? $_REQUEST['PM'] : '',
			'STATUS'	=>	isset($_REQUEST['STATUS']) ? $_REQUEST['STATUS'] : '',
			'CARDNO'	=>	isset($_REQUEST['CARDNO']) ? $_REQUEST['CARDNO'] : '',
			'ED'		=>	isset($_REQUEST['ED']) ? $_REQUEST['ED'] : '',
			'CN'		=>	isset($_REQUEST['CN']) ? $_REQUEST['CN'] : '',
			'TRXDATE'	=>	isset($_REQUEST['TRXDATE']) ? $_REQUEST['TRXDATE'] : '',
			'PAYID'		=>	isset($_REQUEST['PAYID']) ? $_REQUEST['PAYID'] : '',
			'NCERROR'	=>	isset($_REQUEST['NCERROR']) ? $_REQUEST['NCERROR'] : '',
			'BRAND'		=>	isset($_REQUEST['BRAND']) ? $_REQUEST['BRAND'] : '',
			'IP'		=>	isset($_REQUEST['IP']) ? $_REQUEST['IP'] : '',
			'AAVADDRESS'    =>	isset($_REQUEST['AAVADDRESS']) ? $_REQUEST['AAVADDRESS'] : '',
			'AAVCHECK'	=>	isset($_REQUEST['AAVCheck']) ? $_REQUEST['AAVCheck'] : ($this->aavscheck == 'yes')? 'NO' : '',
			'AAVZIP'	=>	isset($_REQUEST['AAVZIP']) ? $_REQUEST['AAVZIP'] : '',
			'AAVMAIL'	=>	isset($_REQUEST['AAVMAIL']) ? $_REQUEST['AAVMAIL'] : '',
			'AAVNAME'	=>	isset($_REQUEST['AAVNAME']) ? $_REQUEST['AAVNAME'] : '',
			'AAVPHONE'	=>	isset($_REQUEST['AAVPHONE']) ? $_REQUEST['AAVPHONE'] : '',
			'ACCEPTANCE'    =>	isset($_REQUEST['ACCEPTANCE']) ? $_REQUEST['ACCEPTANCE'] : '',
			'BIN'		=>	isset($_REQUEST['BIN']) ? $_REQUEST['BIN'] : '',
			'CCCTY'		=>	isset($_REQUEST['CCCTY']) ? $_REQUEST['CCCTY'] : '',
			'COMPLUS'	=>	isset($_REQUEST['COMPLUS']) ? $_REQUEST['COMPLUS'] : '',
			'CVCCHECK'	=>	isset($_REQUEST['CVCCheck']) ? $_REQUEST['CVCCheck'] : ($this->cvccheck == 'yes')? 'NO' : '',
			'ECI'		=>	isset($_REQUEST['ECI']) ? $_REQUEST['ECI'] : '',
			'FXAMOUNT'	=>	isset($_REQUEST['FXAMOUNT']) ? $_REQUEST['FXAMOUNT'] : '',
			'FXCURRENCY'    =>	isset($_REQUEST['FXCURRENCY']) ? $_REQUEST['FXCURRENCY'] : '',
			'IPCTY'		=>	isset($_REQUEST['IPCTY']) ? $_REQUEST['IPCTY'] : '',
			'SUBBRAND'	=>	isset($_REQUEST['SUBBRAND']) ? $_REQUEST['SUBBRAND'] : '',
			'VC'		=>	isset($_REQUEST['VC']) ? $_REQUEST['VC'] : '',
		);

		$SHASIGN = isset($_REQUEST['SHASIGN']) ? $_REQUEST['SHASIGN'] : '';
		ksort($check_data);
		$xy = '';

		foreach($check_data as $k=>$v){
			if( $v=='' )	continue;
			$xy.=strtoupper($k).'='.$v.$this->sha_out;
		}

		if( $this->sha_method == 0 )
			$shasignxy = sha1($xy);
		elseif ( $this->sha_method == 1 )
			$shasignxy = hash('sha256',$xy);
		elseif ( $this->sha_method == 2 )
			$shasignxy = hash('sha512',$xy);


		if( strtolower($shasignxy) == strtolower($SHASIGN) ){
			$this->successfull_transaction( $check_data );
		} else {
			wp_die('Transaction verification error!');
		}

}

function successfull_transaction($args){


    	global $woocommerce;


    	extract($args);

			$order = new WC_Order( $args['ORDERID'] );


				$accepted = array(4, 5, 9, 41, 51, 91);
				$STATUS = $args['STATUS'];
				$ncerror = $args['NCERROR'];

				$dienote = '<p>Transection result is uncertain.<p>';
				$dienote .= '<p>Status Code: ' . $STATUS . ' - ' . $this->get_epdq_status_code($STATUS) . '';
				$dienote .= '<br>Error Code: ' . $ncerror . ' - ' . $this->get_epdq_ncerror($ncerror) . '</p>';
				$died = '';
				$died .= $dienote;
				$died .= '<p>Your order is cancelled and your cart is emptied.';
				$died .= '<br>Go to your <a href="' . get_permalink(get_option('woocommerce_myaccount_page_id')) . '">account</a> to process your order again or ';
				$died .= 'go to <a href="' . home_url() . '">homepage</a></p>';

				if (in_array($STATUS, $accepted)) {

						if (!empty($args['ORDERID']))
								$note = 'Order ID: ' . $args['ORDERID'] . '.<br><br>'; //	order id
						if (!empty($args['AMOUNT']))
								$note .= 'Amount: ' . $args['AMOUNT'] . '.<br><br>'; //	amount
						if (!empty($args['CURRENCY']))
								$note .= 'Order currency: ' . $args['CURRENCY'] . '.<br><br>'; //	order currency
						if (!empty($args['PM']))
								$note .= 'Payment Method: ' . $args['PM'] . '.<br><br>'; //	payment method
						if (!empty($args['ACCEPTANCE']))
								$note .= 'Acceptance code returned by acquirer: ' . $args['ACCEPTANCE'] . '.<br><br>';    //	acceptance
						if (!empty($args['STATUS']))
								$note .= 'Transaction status : ' . $args['STATUS'] . '.<br><br>'; //	status code
						if (!empty($args['PAYID']))
								$note .= 'Payment reference in EPDQ system: ' . $args['PAYID'] . '.<br><br>'; //	pay id
						if (!empty($args['NCERROR']))
								$note .= 'Error Code: ' . $args['NCERROR'] . '.<br><br>'; //	ncerror
						if (!empty($args['BRAND']))
								$note .= 'Card brand (EPDQ system derives this from the card number) : ' . $args['BRAND'] . '.<br><br>'; //	brand

						if (!empty($args['TRXDATE']))
								$note .= 'Transaction Date: ' . $args['TRXDATE'] . '.<br><br>'; //	date
						if (!empty($args['CN']))
								$note .= 'Cardholder/customer name: ' . $args['CN'] . '.<br><br>'; //	payer's name
						if (!empty($args['IP']))
								$note .= 'Customer\'s IP: ' . $args['IP'] . '.<br><br>'; //	payer's ip

						if (!empty($args['AAVADDRESS']))
								$note .= 'AAV result for the address: ' . $args['AAVADDRESS'] . ' . <br><br>'; //	aav address
						if (!empty($args['AAVCHECK']))
								$note .= 'Result of the automatic address verification: ' . $args['AAVCHECK'] . ' . <br><br>'; //	aav check
						if (!empty($args['AAVZIP']))
								$note .= 'AAV result for the zip code: ' . $args['AAVZIP'] . ' . <br><br>'; // aav zip

						if (!empty($args['CCCTY']))
								$note .= 'Country where the card was issued: ' . $args['CCCTY'] . ' . <br><br>';
						if (!empty($args['COMPLUS']))
								$note .= 'Custom value passed: ' . $args['COMPLUS'] . ' . <br><br>';

						if (!empty($args['CVCCHECK']))
								$note .= 'Result of the card verification code check: ' . $args['CVCCHECK'] . ' . <br><br>';
						if (!empty($args['ECI']))
								$note .= 'Electronic Commerce Indicator: ' . $args['ECI'] . ' . <br><br>';
						if (!empty($args['FXAMOUNT']))
								$note .= 'FXAMOUNT: ' . $args['FXAMOUNT'] . ' . <br><br>';
						if (!empty($args['FXCURRENCY']))
								$note .= 'FXCURRENCY: ' . $args['FXCURRENCY'] . ' . <br><br>';
						if (!empty($args['IPCTY']))
								$note .= 'Originating country of the IP address: ' . $args['IPCTY'] . ' . <br><br>';
						if (!empty($args['SUBBRAND']))
								$note .= 'SUBBRAND: ' . $args['SUBBRAND'] . ' . <br><br>';
						if (!empty($args['VC']))
								$note .= 'Virtual Card type: ' . $args['VC'] . ' . <br><br>';

								// Store these for later
								if (isset($args['ORDERID'])) {
									update_post_meta($order->id, 'OrderID', $args['ORDERID']);
								}
								if (isset($args['AMOUNT'])) {
									update_post_meta($order->id, 'OrderAmount', $args['AMOUNT']);
								}
								if (isset($args['CURRENCY'])) {
									update_post_meta($order->id, 'OrderCurrency', $args['CURRENCY']);
								}
								if (isset($args['PM'])) {
									update_post_meta($order->id, 'PaymentMethod', $args['PM']);
								}
								if (isset($args['ACCEPTANCE'])) {
									update_post_meta($order->id, 'Acceptance', $args['ACCEPTANCE']);
								}
								if (isset($args['STATUS'])) {
									update_post_meta($order->id, 'Status', $args['STATUS']);
								}
								if (isset($args['PAYID'])) {
									update_post_meta($order->id, 'PAYID', $args['PAYID']);
								}
								if (isset($args['NCERROR'])) {
									update_post_meta($order->id, 'NCERROR', $args['NCERROR']);
								}
								if (isset($args['BRAND'])) {
									update_post_meta($order->id, 'BRAND', $args['BRAND']);
								}
								if (isset($args['TRXDATE'])) {
									update_post_meta($order->id, 'TRXDATE', $args['TRXDATE']);
								}
								if (isset($args['IP'])) {
									update_post_meta($order->id, 'IP', $args['IP']);
								}
								update_post_meta( $order->id, '_transaction_id', $args['PAYID'] );


						$woocommerce->cart->empty_cart();

						if (in_array($STATUS, array(4, 5, 9))) {
							$noteTitle = 'Barclay ePDQ transaction is confirmed.';
							$order->add_order_note($note);
							$order->add_order_note($noteTitle);
							$order->payment_complete();

						}

						if (in_array($STATUS, array(41, 51, 91))) {
								$note = 'Barclay ePDQ transaction is awaiting for confirmation.<br>';
								$note .= $note;
								$order->update_status('on-hold', $note);
						}

				} elseif ($STATUS == 2 || $STATUS == 93) {
						$dienote .= '<br>Order is failed.';
						$order->update_status('failed', $dienote);
						$woocommerce->cart->empty_cart();
				} elseif ($STATUS == 52 || $STATUS == 92) {
						$dienote .= '<br>Order is failed.';
						$order->update_status('failed', $dienote);
						$woocommerce->cart->empty_cart();
				} elseif ($STATUS == 1) {
						$dienote .= '<br>Order is cancelled.';
						$order->update_status('cancelled', $dienote);
						$woocommerce->cart->empty_cart();
				} else {
						$dienote .= '<br>Order is failed.';
						$order->update_status('failed', $dienote);
						$woocommerce->cart->empty_cart();
				}


				wp_redirect($order->get_checkout_order_received_url());
        exit;

	}


	public function process_refund( $order_id, $amount = NULL, $reason = '' ) {

					$order 			   = new WC_Order( $order_id );
					$refund_amount  = $amount * 100;
					$transaction_id = get_post_meta( $order_id, 'PAYID', true );


					if($this->status=='test')	$environment_url = 'https://mdepayments.epdq.co.uk/ncol/test/maintenancedirect.asp';
					if($this->status=='live')	$environment_url = 'https://mdepayments.epdq.co.uk/ncol/prod/maintenancedirect.asp';

					if ( ! $transaction_id ) {
						return new WP_Error( 'error', __( 'Refund failed: Transaction ID not found.', 'ag_epdq_checkout' ) );
					}
					if ( ! $refund_amount ) {
						return new WP_Error( 'error', __( 'Refund failed: Amount invalid.', 'ag_epdq_checkout' ) );
					}


					$data_post;
					$data_post['AMOUNT'] = $refund_amount;
					$data_post['OPERATION'] = 'RFD';
					$data_post['PAYID'] = $transaction_id;
					$data_post['PSPID'] = $this->access_key;
					$data_post['PSWD'] = $this->api_password;
					$data_post['USERID'] = $this->api_user;

					$post_string = '';

					foreach ($data_post as $key => $value) {
					  $post_string[] = $key. '=' .$value;
					}
					$actual_string = '';
					$actual_string = implode ('&', $post_string);
					$result = wp_remote_post($environment_url, array(
					  'method' => 'POST',
					  'timeout'     => 6,
					  'redirection' => 5,
					  'body' => $actual_string,
					));
					$lines = preg_split('/\r\n|\r|\n/', $result['body']);
					$response = array();
					foreach ($lines as $line) {
					    $key_value = preg_split('/=/', $line, 2);
					    if (count($key_value) > 1) {
					        $response[trim($key_value[0])] = trim($key_value[1]);
					    }
					}

					$accepted = array(8, 81, 85); // OK

					$status = preg_replace('/[^a-zA-Z0-9\s]/', '', $response['STATUS']);
					$error = preg_replace('/[^a-zA-Z0-9\s]/', '', $response['NCERROR']);

					$string = implode('|',$response);

					if (!is_wp_error($result) && $result['response']['code'] >= 200 && $result['response']['code'] < 300) {

					  if (in_array($status, $accepted)) {
							$order->add_order_note( __('Refund successful', 'ag_epdq_checkout') . '<br />' .
								__('Refund Amount: ', 'ag_epdq_checkout') . $refund_amount . '<br />' .
								__('Refund Reason: ', 'ag_epdq_checkout') . $reason . '<br />' .
								__('ePDQ Status: ', 'ag_epdq_checkout') . get_epdq_status_code($status) . ' '
						);

						return true;


					  } else {
					    $order->add_order_note( __('Refund failed', 'ag_epdq_checkout') . '<br />' . __('ePDQ Status: ', 'ag_epdq_checkout') . get_epdq_status_code($status) . '<br />' );
							$order->add_order_note( __('Refund failed', 'ag_epdq_checkout') . '<br />' . __('ePDQ Error note: ', 'ag_epdq_checkout') . $string . '<br />' );
							$order->add_order_note( __('Debug note:', 'ag_epdq_checkout') . '<br />Refund only possiable once payment has been confirmed in the ePDQ back office.<br />' );

					  }

					}


		}

	public function get_epdq_status_code($code){
		if( $code == '' )
			return;
		$codes =  array(
			0=>'Incomplete or invalid',
			1=>'Cancelled by client',
			2=>'Authorisation refused',
			4=>'Order stored',
			40=>'Stored waiting external result',
			41=>'Waiting client payment',
			5=>'Authorised',
			51=>'Authorisation waiting',
			52=>'Authorisation not known',
			55=>'Standby',
			56=>'OK with scheduled payments',
			57=>'Not OK with scheduled payments',
			59=>'Author. to get manually',
			6=>'Authorised and canceled',
			61=>'Author. deletion waiting',
			62=>'Author. deletion uncertain',
			63=>'Author. deletion refused',
			64=>'Authorised and cancelled',
			7=>'Payment deleted',
			71=>'Payment deletion pending',
			72=>'Payment deletion uncertain',
			73=>'Payment deletion refused',
			74=>'Payment deleted (not accepted)',
			75=>'Deletion processed by merchant',
			8=>'Refund',
			81=>'Refund pending',
			82=>'Refund uncertain',
			83=>'Refund refused',
			84=>'Payment declined by the acquirer (will be debited)',
			85=>'Refund processed by merchant',
			9=>'Payment requested',
			91=>'Payment processing',
			92=>'Payment uncertain',
			93=>'Payment refused',
			94=>'Refund declined by the acquirer',
			95=>'Payment processed by merchant',
			96=>'Refund reversed',
			97=>'Being processed - intermediate technical status',
			98=>'Being processed - intermediate technical status',
			99=>'Being processed - intermediate technical status'
		);
		if (isset($codes[$code]))
			return $codes[$code];
		else
			return 'Unknown';
	}

	public function get_epdq_ncerror($code) {
		if ($code == '')
			return;

		$code = (int) $code;
		$ncerorr_list=array(

			20001001=>'Authorisation failed. Please retry.',
			20001002=>'Authorisation failed. Please retry.',
			20001003=>'Authorisation failed. Please retry.',
			20001004=>'Authorisation failed. Please retry.',
			20001005=>'Authorisation failed. Please retry.',
			20001006=>'Authorisation failed. Please retry.',
			20001007=>'Authorisation failed. Please retry.',
			20001008=>'Authorisation failed. Please retry.',
			20001009=>'Authorisation failed. Please retry.',
			20001010=>'Authorisation failed. Please retry.',
			30001999=>'Our payment system is currently under maintenance, please try later.',
			50001005=>'Expiry date error.',
			50001007=>'Requested operation code not permitted.',
			50001008=>'Invalid time limit value.',
			50001010=>'Invalid input date format.',
			50001013=>'Unable to parse socket input stream.',
			50001014=>'Error in parsing stream content.',
			50001015=>'Currency error.',
			50001016=>'Transaction still posted at end of wait.',
			50001017=>'Sync value not compatible with delay value.',
			50001019=>'Duplicate of a pre-existing transaction.',
			50001020=>'Acceptance code required for transaction.',
			50001024=>'Maintenance acquirer differs from original transaction acquirer.',
			50001025=>'Maintenance merchant differs from original transaction merchant.',
			50001028=>'Maintenance operation not appropriate for original transaction.',
			50001031=>'Host application unknown for the transaction.',
			50001032=>'Unable to perform requested operation with requested currency.',
			50001033=>'Maintenance card number differs from original transaction card number.',
			50001034=>'Operation code not permitted.',
			50001035=>'Exception occurred in socket input stream processing.',
			50001036=>'Card length does not correspond to an acceptable value for the brand.',
			50001036=>'Card length does not correspond to an acceptable value for the brand.',
			50001068=>'A technical problem has occurred. Please contact the helpdesk.',
			50001069=>'Invalid check for CardID and Brand.',
			50001070=>'A technical problem has occurred. Please contact the helpdesk.',
			50001116=>'Unknown origin IP.',
			50001117=>'No origin IP detected.',
			50001118=>'Merchant configuration problem. Please contact support.',
			10001001=>'Communication failure.',
			10001002=>'Communication failure.',
			10001003=>'Communication failure.',
			10001004=>'Communication failure.',
			10001005=>'Communication failure.',
			10001016=>'Waiting for acquirer feedback.',
			10001018=>'3XCB pending transaction awaiting for Final status.',
			20001001=>'We have received an unknown status for the transaction. We shall contact your acquirer and update the transaction status within one working day. Please check the status later.',
			20001002=>'We have received an unknown status for the transaction. We shall contact your acquirer and update the status of the transaction within one working day. Please check the status later.',
			20001003=>'We received an unknown status for the transaction. We will contact your acquirer and update the status of the transaction. Please check the status later.',
			20001004=>'We have received an unknown status for the transaction. We shall contact your acquirer and update the transaction status within one working day. Please check the status later.',
			20001005=>'We have received an unknown status for the transaction. We shall contact your acquirer and update the transaction status within one working day. Please check the status later.',
			20001006=>'We have received an unknown status for the transaction. We shall contact your acquirer and update the transaction status within one working day. Please check the status later.',
			20001007=>'We have received an unknown status for the transaction. We shall contact your acquirer and update the transaction status within one working day. Please check the status later.',
			20001008=>'We have received an unknown status for the transaction. We shall contact your acquirer and update the transaction status within one working day. Please check the status later.',
			20001009=>'We have received an unknown status for the transaction. We shall contact your acquirer and update the transaction status within one working day. Please check the status later.',
			20001010=>'We have received an unknown status for the transaction. We shall contact your acquirer and update the transaction status within one working day. Please check the status later.',
			20001101=>'A technical problem has occurred. Please contact the helpdesk.',
			20001104=>'We received an unknown status for the transaction. We will contact your acquirer and update the status of the transaction. Please check the status later.',
			20001105=>'We have received an unknown status for the transaction. We shall contact your acquirer and update the transaction status within one working day. Please check the status later.',
			20001111=>'A technical problem has occurred. Please contact the helpdesk.',
			20001998=>'We received an unknown status for the transaction. We will contact your acquirer and update the status of the transaction. Please check the status later.',
			20002001=>'Bank response origin cannot be checked.',
			20002002=>'Beneficiary account number has been modified during processing.',
			20002003=>'Amount has been modified during processing.',
			20002004=>'Currency has been modified during processing.',
			20002005=>'No feedback detected from the bank server.',
			30001001=>'Payment refused by the financial institution.',
			30001002=>'Duplicate request.',
			30001010=>'A technical problem has occurred. Please contact the helpdesk.',
			30001011=>'A technical problem has occurred. Please contact the helpdesk.',
			30001012=>'Card blacklisted - Contact acquirer.',
			30001015=>'There has been a connection error to the receiving bank. Please try later or choose another payment method.',
			30001016=>'Transmission failure and/or Database error. The transaction could not be properly initialised in the send process (db access failures, etc.).',
			30001051=>'A technical problem has occurred. Please contact the helpdesk.',
			30001054=>'A technical problem has occurred. Please contact the helpdesk.',
			30001056=>'Your merchant\'s acquirer is temporarily unavailable, please try later or choose another payment method.',
			30001057=>'There has been a connection error to the receiving bank. Please try later or choose another payment method.',
			30001058=>'There has been a connection error to the receiving bank. Please try later or choose another payment method.',
			30001060=>'Acquirer has i`ndicated a failure during payment processing.',
			30001070=>'RATEPAY Invalid Response Type (Failure).',
			30001071=>'RATEPAY Missing Mandatory status code field (failure).',
			30001072=>'RATEPAY Missing Mandatory Result code field (failure).',
			30001073=>'RATEPAY Response parsing Failed.',
			30001090=>'CVC check required by front end and returned invalid by acquirer.',
			30001091=>'Postcode check required by front end and returned invalid by acquirer.',
			30001092=>'Address check required by frontend and returned as invalid by acquirer.',
			30001100=>'Unauthorised customer country.',
			30001101=>'IP country differs from card country.',
			30001102=>'Number of different countries too high.',
			30001103=>'unauthorised card country.',
			30001104=>'unauthorised IP address country.',
			30001105=>'Anonymous proxy.',
			30001110=>'If the problem persists, please contact Support or go to paysafecard\'s card balance page (https://customer.cc.at.paysafecard.com/psccustomer/GetWelcomePanelServlet?language=en), to see when the amount reserved on your card will be available again.',
			30001120=>'IP address on merchant\'s blacklist.',
			30001130=>'BIN on merchant\'s blacklist.',
			30001131=>'Wrong BIN for 3xCB.',
			30001140=>'Card on merchant\'s blacklist.',
			30001141=>'E-mail blacklisted.',
			30001142=>'Passenger name blacklisted.',
			30001143=>'Cardholder name blacklisted.',
			30001144=>'Passenger name different from owner name.',
			30001145=>'Time to departure too short.',
			30001149=>'Card Configured in Card Supplier Limit for another relation (CSL).',
			30001150=>'Card not configured in the system for this customer (CSL).',
			30001151=>'REF1 not allowed for this relationship (Contract number).',
			30001152=>'Card/Supplier Amount limit reached (CSL).',
			30001153=>'Card not permitted for this supplier (Date out of contractual limits).',
			30001154=>'You have reached the permitted usage limit.',
			30001155=>'You have reached the permitted usage limit.',
			30001156=>'You have reached the permitted usage limit.',
			30001157=>'Unauthorised IP country for itinerary.',
			30001158=>'e-mail usage limit reached.',
			30001159=>'Unauthorised card country/IP country combination.',
			30001160=>'Postcode in high-risk group.',
			30001161=>'generic blacklist match.',
			30001162=>'Invoicing Address is a PO Box.',
			30001163=>'Airport in high-risk group.',
			30001164=>'Shipping Method in high-risk group.',
			30001165=>'Shipping Method Details in high-risk group.',
			30001166=>'Product Category in high-risk group.',
			30001167=>'Subbrand in high-risk group.',
			30001168=>'Issuer Number in high-risk group.',
			30001169=>'Time to delivery too short.',
			30001180=>'maximum scoring reached.',
			30001997=>'Authorisation cancelled by simulator.',
			30001998=>'A technical problem has occurred. Please try again.',
			30001999=>'There has been a connection error with the receiving bank. Please try later or choose another payment method.',
			30002001=>'Payment refused by the financial institution.',
			30002001=>'Payment refused by the financial institution.',
			30021001=>'Please call the acquirer support call number.',
			30022001=>'Payment must be approved by the acquirer prior to execution.',
			30031001=>'Invalid merchant number.',
			30041001=>'Retain card.',
			30051001=>'Authorisation declined.',
			30051002=>'Voor vragen over uw afwijzing kunt u contact opnemen met de @STARTURL@http://www.afterpay.nl/consument-contact@TXTURL@Klantenservice van AfterPay@ENDURL@.',
			30051009=>'It is possible that you may not have completed all the required information (correctly) during the order process.',
			30051010=>'because your age is under 18. For more information please visit @STARTURL@http://www.afterpay.nl/rej.php?LAN=$LANGUAGE$&TEMPLATE=2@TXTURL@website of AfterPay@ENDURL@.',
			30051011=>'because your address could not be validated. For more information please visit @STARTURL@http://www.afterpay.nl/rej.php?LAN=$LANGUAGE$&TEMPLATE=3@TXTURL@website of AfterPay@ENDURL@.',
			30051012=>'because your emailadres is invalid. For more information please visit @STARTURL@http://www.afterpay.nl/rej.php?LAN=$LANGUAGE$&TEMPLATE=4@TXTURL@website van AfterPay@ENDURL@.',
			30051013=>'because the order amount extends the limit for first time AfterPay users. For more information please visit @STARTURL@http://www.afterpay.nl/rej.php?LAN=$LANGUAGE$&TEMPLATE=5@TXTURL@website of AfterPay@ENDURL@.',
			30051014=>'because there are currently too many outstanding payments at AfterPay. For more information please visit @STARTURL@http://www.afterpay.nl/rej.php?LAN=$LANGUAGE$&TEMPLATE=6@TXTURL@website of AfterPay@ENDURL@.',
			30051015=>'because your chamber of commerce number could not be validated. For more information please visit @STARTURL@http://www.afterpay.nl/rej.php?LAN=$LANGUAGE$&TEMPLATE=7@TXTURL@website of AfterPay@ENDURL@.',
			30051016=>'because the order amount is too low. For more information please visit @STARTURL@http://www.afterpay.nl/rej.php?LAN=$LANGUAGE$&TEMPLATE=8@TXTURL@website of AfterPay@ENDURL@.',
			30051017=>'For more information please visit @STARTURL@http://www.afterpay.nl/rej.php?LAN=$LANGUAGE$&TEMPLATE=1@TXTURL@website of AfterPay@ENDURL@.',
			30071001=>'Retain card - special conditions.',
			30121001=>'Invalid transaction.',
			30131001=>'Invalid amount.',
			30131002=>'You have reached the permitted limit.',
			30141001=>'Invalid card number.',
			30151001=>'Unknown acquiring institution.',
			30171001=>'Payment method cancelled by the customer.',
			30171002=>'The maximum time allowed has elapsed.',
			30191001=>'Please try again later.',
			30201001=>'A technical problem has occurred. Please contact the helpdesk.',
			30301001=>'Invalid format.',
			30311001=>'Unknown acquirer ID.',
			30331001=>'Card expired.',
			30341001=>'Suspicion of fraud.',
			30341001=>'Suspicion of fraud.',
			30341002=>'Suspicion of fraud (3rdMan).',
			30341003=>'Suspicion of fraud (Perseuss).',
			30341004=>'Suspicion of fraud (ETHOCA).',
			30341005=>'Suspicion of fraud (Expert).',
			30381001=>'A technical problem has occurred. Please contact the helpdesk.',
			30401001=>'Invalid function.',
			30411001=>'Lost card.',
			30431001=>'Stolen card. Pick up.',
			30511001=>'Insufficient funds.',
			30521001=>'No Authorisation. Please contact your card issuer.',
			30541001=>'Card expired.',
			30551001=>'Invalid PIN.',
			30561001=>'Card not in authoriser\'s database.',
			30571001=>'Transaction not permitted on card.',
			30581001=>'Transaction not permitted on this terminal.',
			30591001=>'Suspicion of fraud.',
			30601001=>'The merchant should contact the acquirer.',
			30611001=>'Amount exceeds card limit.',
			30621001=>'Restricted card.',
			30631001=>'Security policy not respected.',
			30641001=>'Amount changed from ref. transaction.',
			30681001=>'The maximum allowed time has elapsed.',
			30751001=>'Incorrect PIN entered too many times.',
			30761001=>'Already disputed by cardholder.',
			30771001=>'PIN entry required.',
			30811001=>'Message flow error.',
			30821001=>'Authorisation centre unavailable.',
			30831001=>'Authorisation centre unavailable.',
			30901001=>'Temporary system shutdown.',
			30911001=>'Acquirer unavailable.',
			30921001=>'Invalid card type for acquirer.',
			30941001=>'Duplicate transaction.',
			30961001=>'Processing temporarily not possible.',
			30971001=>'A technical problem has occurred. Please contact the helpdesk.',
			30981001=>'A technical problem has occurred. Please contact the helpdesk.',
			31011001=>'Unknown acceptance code.',
			31021001=>'Invalid currency.',
			31031001=>'Acceptance code missing.',
			31041001=>'Inactive card.',
			31051001=>'Merchant not active.',
			31061001=>'Invalid expiry date.',
			31071001=>'Interrupted host communication.',
			31081001=>'Card refused.',
			31091001=>'Invalid password.',
			31101001=>'Plafond transaction (majoré du bonus) dépassé.',
			31111001=>'Plafond mensuel (majoré du bonus) dépassé.',
			31121001=>'Plafond centre de facturation dépassé.',
			31131001=>'Plafond entreprise dépassé.',
			31141001=>'Code MCC du fournisseur non autorisé pour la carte.',
			31151001=>'Numéro SIRET du fournisseur non autorisé pour la carte.',
			31161001=>'This is not a valid online bank account.',
			32001004=>'A technical problem has occurred. Please try again.',
			32001105=>'A technical problem has occurred. Please contact the helpdesk.',
			34011001=>'Bezahlung mit RatePAY nicht möglich.',
			39991001=>'A technical problem has occurred. Please contact your acquirer\'s helpdesk.',
			40001001=>'A technical problem has occurred. Please try again.',
			40001002=>'A technical problem has occurred. Please try again.',
			40001003=>'A technical problem has occurred. Please try again.',
			40001004=>'A technical problem has occurred. Please try again.',
			40001005=>'A technical problem has occurred. Please try again.',
			40001006=>'A technical problem has occurred. Please try again.',
			40001007=>'A technical problem has occurred. Please try again.',
			40001008=>'A technical problem has occurred. Please try again.',
			40001009=>'A technical problem has occurred. Please try again.',
			40001010=>'A technical problem has occurred. Please try again.',
			40001011=>'A technical problem has occurred. Please contact the helpdesk.',
			40001012=>'There has been a connection error with the receiving bank. Please try later or choose another payment method.',
			40001013=>'A technical problem has occurred. Please contact the helpdesk.',
			40001016=>'A technical problem has occurred. Please contact the helpdesk.',
			40001018=>'A technical problem has occurred. Please try again.',
			40001019=>'Sorry, an error has occurred during processing. Please retry the transaction (using the Back button of the browser). If the problem persists, contact your merchant\'s helpdesk.',
			40001020=>' Sorry, an error occurred during processing. Please retry the operation (using the Back button of the browser). If the problem persists, please contact your merchant\'s helpdesk.',
			40001050=>'A technical problem has occurred. Please contact the helpdesk.',
			40001133=>'Authentication failed. Incorrect signature for your bank\'s access control server.',
			40001134=>'Authentication failed. Please retry or cancel.',
			40001135=>'Authentication temporarily unavailable. Please retry or cancel.',
			40001136=>'Technical problem with your browser. Please retry or cancel.',
			40001137=>'Your bank is temporarily unavailable. Please try again later or choose another payment method.',
			40001998=>'Temporary technical problem. Please retry later.',
			50001001=>'Unknown card type.',
			50001002=>'Card number format check failed for given card number.',
			50001003=>'Merchant data error.',
			50001004=>'Merchant identification missing.',
			50001005=>'Expiry date error.',
			50001006=>'Amount is not a number.',
			50001007=>'A technical has problem occurred. Please contact the helpdesk.',
			50001008=>'A technical has problem occurred. Please contact the helpdesk.',
			50001009=>'A technical has problem occurred. Please contact the helpdesk.',
			50001010=>'A technical has problem occurred. Please contact the helpdesk.',
			50001011=>'Brand not supported for that merchant.',
			50001012=>'A technical has problem occurred. Please contact the helpdesk.',
			50001013=>'A technical has problem occurred. Please contact the helpdesk.',
			50001014=>'A technical has problem occurred. Please contact the helpdesk.',
			50001015=>'Invalid currency code.',
			50001016=>'A technical has problem occurred. Please contact the helpdesk.',
			50001017=>'A technical has problem occurred. Please contact the helpdesk.',
			50001018=>'A technical has problem occurred. Please contact the helpdesk.',
			50001019=>'A technical has problem occurred. Please contact the helpdesk.',
			50001020=>'A technical has problem occurred. Please contact the helpdesk.',
			50001021=>'A technical has problem occurred. Please contact the helpdesk.',
			50001022=>'A technical has problem occurred. Please contact the helpdesk.',
			50001023=>'A technical has problem occurred. Please contact the helpdesk.',
			50001024=>'A technical has problem occurred. Please contact the helpdesk.',
			50001025=>'A technical has problem occurred. Please contact the helpdesk.',
			50001026=>'A technical has problem occurred. Please contact the helpdesk.',
			50001027=>'A technical has problem occurred. Please contact the helpdesk.',
			50001028=>'A technical has problem occurred. Please contact the helpdesk.',
			50001029=>'A technical has problem occurred. Please contact the helpdesk.',
			50001030=>'A technical has problem occurred. Please contact the helpdesk.',
			50001031=>'A technical has problem occurred. Please contact the helpdesk.',
			50001032=>'A technical has problem occurred. Please contact the helpdesk.',
			50001033=>'A technical has problem occurred. Please contact the helpdesk.',
			50001034=>'A technical has problem occurred. Please contact the helpdesk.',
			50001035=>'A technical problem has occurred. Please contact the helpdesk.',
			50001036=>'Incorrect card length for the brand.',
			50001037=>'Purchasing card number for a standard merchant.',
			50001038=>'You should use a purchasing card for this transaction.',
			50001039=>'Details sent for a non-purchasing card merchant. Please contact the helpdesk.',
			50001040=>'Details not sent for a purchasing card transaction. Please contact the helpdesk.',
			50001041=>'Payment detail validation failed.',
			50001042=>'Sum of given transaction amounts (tax, discount, delivery, net, etc.) does not match total.',
			50001043=>'A technical problem has occurred. Please contact the helpdesk.',
			50001044=>'No acquirer configured for this operation.',
			50001045=>'No UID configured for this operation.',
			50001046=>'Operation not permitted for the merchant.',
			50001047=>'A technical problem has occurred. Please contact the helpdesk.',
			50001048=>'A technical problem has occurred. Please contact the helpdesk.',
			50001049=>'A technical problem has occurred. Please contact the helpdesk.',
			50001050=>'A technical problem has occurred. Please contact the helpdesk.',
			50001051=>'A technical problem has occurred. Please contact the helpdesk.',
			50001052=>'A technical problem has occurred. Please contact the helpdesk.',
			50001053=>'A technical problem has occurred. Please contact the helpdesk.',
			50001054=>'Card number incorrect or incompatible.',
			50001055=>'A technical problem has occurred. Please contact the helpdesk.',
			50001056=>'A technical problem has occurred. Please contact the helpdesk.',
			50001057=>'A technical problem has occurred. Please contact the helpdesk.',
			50001058=>'A technical problem has occurred. Please contact the helpdesk.',
			50001059=>'A technical problem has occurred. Please contact the helpdesk.',
			50001060=>'A technical problem has occurred. Please contact the helpdesk.',
			50001061=>'A technical problem has occurred. Please contact the helpdesk.',
			50001062=>'A technical problem has occurred. Please contact the helpdesk.',
			50001063=>'Card Issue Number does not correspond to range or is not present.',
			50001064=>'Start Date invalid or not present.',
			50001066=>'Invalid CVC code format.',
			50001067=>'The merchant is not registered for 3D-Secure.',
			50001068=>'Invalid card number or account number (PAN).',
			50001069=>'Invalid CardID and Brand match.',
			50001070=>'The ECI value is either not supported or conflicts with other transaction data.',
			50001071=>'Incomplete TRN demat.',
			50001072=>'Incomplete PAY demat.',
			50001073=>'No demat APP.',
			50001074=>'Authorisation period expired.',
			50001075=>'VERRes was an error message.',
			50001076=>'DCP amount greater than authorisation amount.',
			50001077=>'Details negative amount.',
			50001078=>'Details negative quantity.',
			50001079=>'Could not decode/decompress received PARes (3D-Secure).',
			50001080=>'Received PARes was an error message from ACS (3D-Secure).',
			50001081=>'Received PARes format was invalid according to the 3DS specifications (3D-Secure).',
			50001082=>'PAReq/PARes reconciliation failure (3D-Secure).',
			50001084=>'Maximum amount reached.',
			50001087=>'This transaction requires authentication. Please check with your bank.',
			50001090=>'CVC missing at input, but CVC check requested.',
			50001091=>'Postcode missing at input, but postcode check requested.',
			50001092=>'Address missing at input, but Address check requested.',
			50001093=>'Partial capture not allowed.',
			50001095=>'Invalid date of birth.',
			50001096=>'Invalid commodity code.',
			50001097=>'The requested currency and brand are incompatible.',
			50001111=>'Data validation error.',
			50001113=>'This order has already been processed.',
			50001114=>'Error in accessing the pre-payment check page.',
			50001115=>'Request not received in secure mode.',
			50001116=>'Unknown IP address origin.',
			50001117=>'No IP address origin.',
			50001118=>'PSPID not found or incorrect.',
			50001119=>'Password incorrect or disabled due to number of errors.',
			50001120=>'Invalid currency.',
			50001121=>'Invalid number of decimals for the currency.',
			50001122=>'Currency not accepted by the merchant.',
			50001123=>'Card type not active.',
			50001124=>'Number of lines doesn\'t match the number of payments.',
			50001125=>'Format validation error.',
			50001126=>'Overflow in data capture requests for the original order.',
			50001127=>'Incorrect original order status.',
			50001128=>'missing authorisation code for unauthorised order.',
			50001129=>'Overflow in refunds requests.',
			50001130=>'Original order access error.',
			50001131=>'Original history item access error.',
			50001132=>'The selected Catalogue is empty.',
			50001133=>'Duplicate request.',
			50001134=>'Authentication failed. Please retry or cancel.',
			50001135=>'Authentication temporarily unavailable. Please retry or cancel.',
			50001136=>'Technical problem with your browser. Please retry or cancel.',
			50001137=>'Your bank is temporarily unavailable. Please try again later or choose another payment method.',
			50001150=>'Fraud Detection: technical error (invalid IP).',
			50001151=>'Fraud detection: technical error (IPCTY unknown or error).',
			50001152=>'Fraud detection: technical error (CCCTY unknown or error).',
			50001153=>'Overflow in redo-authorisation requests.',
			50001170=>'Dynamic BIN check failed.',
			50001171=>'Dynamic country check failed.',
			50001172=>'Amadeus signature error.',
			50001174=>'Cardholder Name is too long.',
			50001175=>'Name contains invalid characters.',
			50001176=>'Card number is too long.',
			50001177=>'Card number contains non-numeric info.',
			50001178=>'Card Number Empty.',
			50001179=>'CVC too long.',
			50001180=>'CVC contains non-numeric info.',
			50001181=>'Expiry date contains non-numeric info.',
			50001182=>'Invalid expiry month.',
			50001183=>'Expiry date must be in the future.',
			50001184=>'SHA Mismatch.',
			50001186=>'Operation not permitted.',
			50001187=>'Operation not permitted.',
			50001205=>'Missing mandatory fields in invoicing address.',
			50001206=>'Missing mandatory date of birth field.',
			50001207=>'Missing required shopping basket details.',
			50001208=>'Missing social security number.',
			50001209=>'Invalid country code.',
			50001210=>'Missing annual salary.',
			50001211=>'Missing gender.',
			50001212=>'Missing e-mail.',
			50001213=>'Missing IP address.',
			50001214=>'Missing part-payment campaign ID.',
			50001215=>'Missing invoice number.',
			50001216=>'The alias must be different to the card number.',
			50001217=>'Invalid details for shopping basket calculation.',
			50001218=>'No Refunds allowed.',
			50001220=>'Invalid format of phone number.',
			50001221=>'Invalid ZIP format.',
			50001222=>'Firstname or/and lastname missing.',
			50001223=>'Firstname and/or lastname format invalid.',
			50001224=>'The phone number is missing.',
			50001225=>'Invalid email format.',
			50001300=>'Wrong brand/payment method.',
			50001301=>'Wrong account number format.',
			50001302=>'RFP operation code is only permitted with scheduled payments.',
			50001303=>'RFP operation code not permitted for a Disputed payment.',
			50001304=>'RFP operation code not permitted - Unpaid amounts.',
			55555555=>'An error occurred.',
			60000001=>'account number unknown.',
			60000003=>'not credited dd-mm-yy.',
			60000005=>'name/number do not match.',
			60000007=>'account number blocked.',
			60000008=>'specific direct debit block.',
			60000009=>'account number WKA.',
			60000010=>'administrative reason.',
			60000011=>'account number expired.',
			60000012=>'no direct debit authorisation.',
			60000013=>'debit not approved.',
			60000014=>'double payment.',
			60000018=>'name/address/city not entered.',
			60001001=>'no original direct debit for revocation.',
			60001002=>'payer\'s account number format error.',
			60001004=>'payer\'s account at different bank.',
			60001005=>'payee\'s account at different bank.',
			60001006=>'payee\'s account number format error.',
			60001007=>'payer\'s account number blocked.',
			60001008=>'payer\'s account number expired.',
			60001009=>'payee\'s account number expired.',
			60001010=>'direct debit not possible.',
			60001011=>'creditor payment not possible.',
			60001012=>'payer\'s account number unknown WKA-number.',
			60001013=>'payee\'s account number unknown WKA-number.',
			60001014=>'WKA transaction not permitted.',
			60001015=>'revocation period expired.',
			60001017=>'incorrect revocation reason.',
			60001018=>'original run number not numeric.',
			60001019=>'payment ID incorrect.',
			60001020=>'amount not numeric.',
			60001021=>'zero amount not permitted.',
			60001022=>'negative amount not permitted.',
			60001023=>'payer and payee giro account number.',
			60001025=>'processing code (verwerkingscode) incorrect.',
			60001028=>'revocation not permitted.',
			60001029=>'guaranteed direct debit on giro account number.',
			60001030=>'NBC transaction type incorrect.',
			60001031=>'description too long.',
			60001032=>'book account number not issued.',
			60001034=>'book account number incorrect.',
			60001035=>'payer\'s account number not numeric.',
			60001036=>'payer\'s account number not eleven-proof.',
			60001037=>'payer\'s account number not issued.',
			60001039=>'payer\'s account number of DNB/BGC/BLA.',
			60001040=>'payee\'s account number not numeric.',
			60001041=>'payee\'s account number not eleven-proof.',
			60001042=>'payee\'s account number not issued.',
			60001044=>'payee\'s account number unknown.',
			60001050=>'payee\'s name missing.',
			60001051=>'indicate payee\'s bank account number instead of 3102.',
			60001052=>'no direct debit contract.',
			60001053=>'amount beyond limits.',
			60001054=>'selective direct debit block.',
			60001055=>'original run number unknown.',
			60001057=>'payer\'s name missing.',
			60001058=>'payee\'s account number missing.',
			60001059=>'restore not permitted.',
			60001060=>'bank\'s reference (navraaggegeven) missing.',
			60001061=>'BEC/GBK number incorrect.',
			60001062=>'BEC/GBK code incorrect.',
			60001087=>'book account number not numeric.',
			60001090=>'cancelled on request.',
			60001091=>'cancellation order executed.',
			60001092=>'cancelled instead of ended.',
			60001093=>'book account number is a shortened account number.',
			60001094=>'instructing party and payer account numbers do not match.',
			60001095=>'payee unknown GBK acceptor.',
			60001097=>'instructing party and payee account numbers do not match.',
			60001099=>'clearing not permitted.',
			60001101=>'payer\'s account number has no spaces.',
			60001102=>'PAN length not numeric.',
			60001103=>'PAN length outside limits.',
			60001104=>'track number not numeric.',
			60001105=>'track number not valid.',
			60001106=>'PAN sequence number not numeric.',
			60001107=>'domestic PAN not numeric.',
			60001108=>'domestic PAN not eleven-proof.',
			60001109=>'domestic PAN not issued.',
			60001110=>'foreign PAN not numeric.',
			60001111=>'card validity date not numeric.',
			60001112=>'book period number (boekperiodenr) not numeric.',
			60001113=>'transaction number not numeric.',
			60001114=>'transaction time not numeric.',
			60001115=>'invalid transaction time.',
			60001116=>'transaction date not numeric.',
			60001117=>'invalid transaction date.',
			60001118=>'STAN not numeric.',
			60001119=>'instructing party\'s name missing.',
			60001120=>'foreign amount (bedrag-vv) not numeric.',
			60001122=>'rate (verrekenkoers) not numeric.',
			60001125=>'number of decimals (aantaldecimalen) incorrect.',
			60001126=>'tariff (tarifering) not B/O/S.',
			60001127=>'domestic costs (kostenbinnenland) not numeric.',
			60001128=>'domestic costs (kostenbinnenland) not higher than zero.',
			60001129=>'foreign costs (kostenbuitenland) not numeric.',
			60001130=>'foreign costs (kostenbuitenland) not higher than zero.',
			60001131=>'domestic costs (kostenbinnenland) not zero.',
			60001132=>'foreign costs (kostenbuitenland) not zero.',
			60001134=>'Euro record not completed.',
			60001135=>'Customer currency incorrect.',
			60001136=>'NLG amount not numeric.',
			60001137=>'NLG amount not higher than zero.',
			60001138=>'NLG amount not equal to Amount.',
			60001139=>'NLG amount incorrectly converted.',
			60001140=>'EUR amount not numeric.',
			60001141=>'EUR amount not greater than zero.',
			60001142=>'EUR amount not equal to Amount.',
			60001143=>'EUR amount incorrectly converted.',
			60001144=>'Customer currency not NLG.',
			60001145=>'rate euro-vv (Koerseuro-vv) not numeric.',
			60001146=>'comma rate euro-vv (Kommakoerseuro-vv) incorrect.',
			60001147=>'invalid acceptgiro distributor.',
			60001148=>'Original run number and/or BRN missing.',
			60001149=>'Amount/Account number/ BRN different.',
			60001150=>'Direct debit already revoked/restored.',
			60001151=>'Direct debit already reversed/revoked/restored.',
			60001153=>'Payer\'s account number not know.',
		);


		if( isset($ncerorr_list[$code] ))
			return $ncerorr_list[$code];
		else
			return 'Unknown';
	}

}
